/*
	MCP2210DLL-UM.h - headder file for MCP2210DLL-UM.dll(Version 1.2.0)
	
	2015/03/27 N.Yamazaki creation. (from "Using the Unmanaged DLL.pdf")
*/
#ifndef _MCP2210DLL_UM_H_
#define _MCP2210DLL_UM_H_
#ifdef __cplusplus
extern "C"{
#endif
#include <windows.h>

//The two constants below are the same - user chooses which is more intuitive 
static const int OFF = 0; 
static const int DISABLED = 0; 
//The two constants below are the same - user chooses which is more intuitive 
static const int ON = 1;
static const int ENABLED = 1; 
//Constants to be used for all whichTo(Get/Set) variables in DLL functions 
static const int CURRENT_SETTINGS_ONLY = 0; 
static const int PWRUP_DEFAULTS_ONLY = 1; 
static const int BOTH = 2;


void __stdcall DllInit(UINT32 VendorID, UINT32 ProductID);
void __stdcall DllCleanUp();
//// EEPROM Operations 
int __stdcall WriteEEProm(BYTE address, BYTE content);
int __stdcall ReadEEProm(BYTE address);
//// GPIO
int __stdcall GetGpioPinDir();
int __stdcall SetGpioPinDir(WORD gpioDir);
int __stdcall GetGpioPinVal();
int __stdcall SetGpioPinVal(WORD gpioVal);
//// Password Operations
//int  __stdcall EnterAccessPasswd(String^ passwd);
int  __stdcall GetPasswdAttmptCnt();
int  __stdcall GetPasswdAccessStatus();
//// SPI Bus Operations
int  __stdcall RequestSpiBusRel();
int  __stdcall TxferSpiData(BYTE* txData, BYTE* rxData);
int  __stdcall CancelSpiTxfer();
//// Other Chip Status Information
int  __stdcall GetEvntCntFromIntPin();
int  __stdcall GetSpiBusRelExtReqStatus();
int  __stdcall GetSpiBusCurOwner();
//// USB Related
INT64  __stdcall GetVid();
INT64  __stdcall GetPid();
int  __stdcall GetVidPid(UINT32* vid, UINT32* pid);
int  __stdcall SetVidPid(UINT32 vid, UINT32 pid);
int  __stdcall GetSerialNumber(WCHAR* serialNumber);
bool  __stdcall GetConnectionStatus();
int  __stdcall GetPwrConfigSrc();
int  __stdcall GetPwrConfigRmtWkupCpbl();
int  __stdcall GetPwrConfig(int* pwrSrc, bool* isRmtWkupCpble);
int  __stdcall SetPwrConfig(int pwrSrc, bool isRmtWkupCpble);
int  __stdcall GetReqdCurrentLd();
int  __stdcall SetReqdCurrentLd(int current);
int  __stdcall GetStringManufacturer(WCHAR*);
int  __stdcall SetStringManufacturer(WCHAR* newString);
int  __stdcall GetStringDescriptor(WCHAR*);
int  __stdcall SetStringDescriptor(WCHAR* newString);
//// Chip Access Settings
int  __stdcall GetPermanentDevLockStatus();
int  __stdcall SetPermanentDevLock();
int  __stdcall GetPasswdEnStatus();
int  __stdcall SetPasswdEnStatus(bool onOff, char* newPasswd);
//int SetNewPasswd(String^ curPasswd, char* newPasswd);
//// Chip Settings
int  __stdcall GetAllChipSettings(int whichToGet, BYTE* gpioPinDes,int* gpioDfltOutput, int* gpioDfltDir,bool* rmtWkupEn, BYTE* intPinMd,bool* spiBusRelEn);
int  __stdcall SetAllChipSettings(int whichToSet, BYTE* gpioPinDes,int gpioDfltOutput, int gpioDfltDir,bool rmtWkupEn, BYTE intPinMd,bool spiBusRelEn);
int  __stdcall GetGpioDfltOutput(int whichToGet);
int  __stdcall GetGpioDfltDirection(int whichToGet);
int  __stdcall GetGpioPinDesignations(int whichToGet,BYTE* gpioPinDes);
int  __stdcall GetGpioConfig(int whichToSet, BYTE* gpioPinDes,int* gpioOutputDflt, int* gpioDir);
int  __stdcall SetGpioConfig(int whichToSet, BYTE* gpioPinDes,int gpioOutputDflt, int gpioDir);
int  __stdcall GetRmtWkupEnStatus(int whichToGet);
int  __stdcall SetRmtWkupEnStatus(int whichToSet, bool enStatus);
int  __stdcall GetInterruptPinMode(int whichToGet);
int  __stdcall SetInterruptPinMode(int whichToSet, int intPinMode);
int  __stdcall GetSpiBusReleaseEnStatus(int whichToGet);
int  __stdcall SetSpiBusReleaseEnStatus(int whichToSet, bool spiBusRelEn);
//// SPI Settings
int  __stdcall GetAllSpiSettings(int whichToGet, UINT32* bitRate,WORD* idleCsVal, WORD* activeCsVal,WORD* csToDataDly, WORD* dataToDataDly,WORD* dataToCsDly, WORD* txferSize,BYTE* spiMd);
int  __stdcall SetAllSpiSettings(int whichToSet, UINT32 bitRate,WORD idleCsVal, WORD activeCsVal,WORD csToDataDly, WORD dataToDataDly,WORD dataToCsDly, WORD txferSize,BYTE spiMd);
int  __stdcall GetSpiBitRate(int whichToGet);
int  __stdcall SetSpiBitRate(int whichToSet, UINT32 bitRate);
int  __stdcall GetSpiIdleCsValue(int whichToGet);
int  __stdcall GetSpiActiveCsValue(int whichToGet);
int  __stdcall GetSpiCsValues(int whichToGet, WORD* csIdleCsVal, WORD* csActiveVal);
int  __stdcall SetSpiCsValues(int whichToSet, WORD csIdleCsVal, WORD csActiveVal);
int  __stdcall GetSpiDelayCsToData(int whichToGet);
int  __stdcall GetSpiDelayDataToData(int whichToGet);
int  __stdcall GetSpiDelayDataToCs(int whichToGet);
int  __stdcall GetSpiDelays(int whichToGet, WORD* csToDataDly, WORD* dataToDataDly,WORD* dataToCsDly);
int  __stdcall SetSpiDelays(int whichToSet, WORD csToDataDly, WORD dataToDataDly,WORD dataToCsDly);
int  __stdcall GetSpiTxferSize(int whichToGet);
int  __stdcall SetSpiTxferSize(int whichToSet, WORD txferSize);
int  __stdcall GetSpiMode(int whichToGet);
int  __stdcall SetSpiMode(int whichToSet, BYTE spiMode);
//// Multiple Device Support
int  __stdcall GetDeviceCount();
int  __stdcall GetSelectedDevNum();
//String& GetSelectedDevInfo()
int  __stdcall SelectDev(int devNum);

#ifdef __cplusplus
}
#endif
#endif
